orion.craft = {}
orion.craft.type = {}


orion.craft.register = function(craft_type, inputs, outputs)
	--local err, craft_type, recipe, output = orion.args(3, "craft_type", "inputs", "outputs", arg)
	--if err then return false, err end

	if #inputs > 32 then return false, "Maximum 32 inputs for recipe" end
	if #outputs > 32 then return false, "Maximum 32 outputs for recipe" end

	inputs = table.sort(inputs)

	if not orion.craft.type[craft_type] then orion.craft.type[craft_type] = {} end
	local present = false
	for i in pairs(orion.craft.type[craft_type]) do
		present = true
		for x = 1, #i do
			if i[x] ~= inputs[x] then
				present = false
				break
			end
			if present then break end
		end
	end
	if present then
		return false, "recipe already asigned!"
	end
	table.insert(orion.craft.type[craft_type], table)
	return true
end


orion.register_craftitem = function(name, description)
	minetest.register_craftitem(NAME .. ":" .. name, {
		description = description,
		inventory_image = NAME .. "_" .. name .. ".png"
	})
end
