-- my hand the stand
minetest.override_item("", {
	wield_image = "orionplayer_hand.png",
	groups = {not_in_creative_inventory=1},
	tool_capabilities = {
		groupcaps = {
			flora = {
				times = {
					[1] = 0.4
				},
				maxlevel = 1
			},
			semisolids = {
				times = {
					[1] = 2
				},
				maxlevel = 1
			}
		}
	}
})

minetest.register_on_player_hpchange(function(player, hp_change, reason)
	if reason.type == "fall" then return 0, true end
end, true)

local function update_scale(player, scale)
	player:set_properties({
		eye_height = 1.45 * scale,
		visual_size ={
			x=0.825 * scale,
			y=1.7 * scale,
			z=0.825 * scale
		},
		collisionbox = { -0.4125 * scale, 0.0, -0.415 * scale, 0.4125 * scale , 1.7 * scale, 0.4125 * scale }
		})
		
	player:set_physics_override({
		jump= 0.9 * scale,
		gravity= 0.9,
		speed= 1.1 * scale
	})
end

local function make_scale(player)
		local shaplayer = minetest.sha1(player:get_player_name(), true)
		local rand = shaplayer:byte(1)
		local scale = shaplayer:byte(1) / 256 /2
		scale = scale + 0.75
		return scale
end

minetest.register_chatcommand("scale", {
	params = "[player] <scale>",
	description = "Scale a player",
	privs = {debug=true},
	func = function(name, param)
		local params = string.split(param, ' ')
		if #params > 2 or #params == 0 then return false end
		local playerObj = nil
		if #params == 1 then
			playerObj = minetest.get_player_by_name(name)
			scale = tonumber(params[1])	
		else
			playerObj = minetest.get_player_by_name(params[1])
			scale = tonumber(params[2])
		end
		if not scale then return false, "provided scale needs to be a float" end
		if scale == 0 then return false, "provided scale cannot be 0!" end
		if not playerObj then return false, "player not found" end
		update_scale(playerObj, scale)
		local playermeta = playerObj:get_meta()
		playermeta:set_float("scale", scale)
	end
})


minetest.register_chatcommand("resetscale", {
	params = "[player]",
	description = "resets a player scale",
	privs = {debug=true},
	func = function(name, param)
		local params = string.split(param, ' ')
		if #params > 1 then return false end
		local playerObj = nil
		if #params == 0 then
			playerObj = minetest.get_player_by_name(name)
		else
			playerObj = minetest.get_player_by_name(params[1])
		end
		if not playerObj then return false, "player not found" end
		local scale = make_scale(playerObj)
		update_scale(playerObj, scale)
		local playermeta = playerObj:get_meta()
		playermeta:set_float("scale", 0)
	end
})

local function fillInventory(player, creative)
	local inventory = player:get_inventory()
	inventory:set_list("crafting", nil)
	inventory:set_size("crafting", 500)
	if creative then
		for name, node in pairs(minetest.registered_nodes) do
			inventory:add_item("crafting", ItemStack(node.name .. " 256"))
		end
		--for name, item in pairs(minetest.registered_items) do
		--	inventory:add_item("crafting", ItemStack(item.name .. " 256"))
		--end
		for name, tools in pairs(minetest.registered_tools) do
			local newTool = ItemStack(tools.name)
			local meta = newTool:get_meta()
			local chargeable = tools.groups.sparktech_chargeable
			minetest.debug(dump2(tools))
			if chargeable then
				meta:set_int("energy", chargeable)
				newTool:set_wear(1)
				meta:set_tool_capabilities(tools.spark_caps_charge)
			end
			inventory:add_item("crafting", newTool)
		end
	end
end


minetest.register_on_player_inventory_action(function(player, action, inventory, inventory_info)
	minetest.debug(dump2(action))
	minetest.debug(dump2(inventory))
	minetest.debug(dump2(inventory_info))
end)


minetest.register_on_joinplayer(function(player)
	player:set_properties({zoom_fov = 45})
	local meta = player:get_meta()
	local scale = meta:get_float("scale")
	if scale == 0 or not scale then
		scale = make_scale(player)
	end
	update_scale(player, scale)
	
	local inventory = player:get_inventory()
	--FIXMT: engine hardcodes this
	inventory:set_list("craft", nil)
	inventory:set_list("craftpreview", nil)
	inventory:set_list("craftresult", nil)
	
	--player:set_lighting({shadows = { intensity = 0.33} })

	fillInventory(player, true)
	local lists = inventory:get_lists()
end)
