local NAME = minetest.get_current_modname()
local MAX_ENERGY = 30

local timer = function(pos, elapsed, light_level)
	local meta = minetest.get_meta(pos)
	local energy = meta:get_int("energy")
	
	if energy >= light_level or not sparktech.getoption(pos, "enabled") then
		energy = energy - light_level
		meta:set_int("energy", energy)
	else
		minetest.swap_node(pos, {name = NAME .. ":light_off"})
		minetest.get_node_timer(pos):start(1.0) -- TODO: energy wakeup?
		return
	end
	if energy <= light_level then
		minetest.swap_node(pos, {name = NAME .. ":light_off"})
	elseif energy < 10 then
		minetest.swap_node(pos, {name = NAME .. ":light_lv1"})
	elseif energy < 20 then
		minetest.swap_node(pos, {name = NAME .. ":light_lv2"})
	else
		minetest.swap_node(pos, {name = NAME .. ":light_lv3"})
	end
	minetest.get_node_timer(pos):start(1.0) -- TODO: energy wakeup?
end

minetest.register_node(NAME .. ":light_off", {
  description = "Unpowered light",
  tiles = {
    NAME .. "_lamp_off.png",
  },
	on_timer = function(pos, elapsed) timer(pos, elapsed, 0) end,
	on_construct = function(pos, elapsed) timer(pos, elapsed, 0) end,
	groups = {
		sparktech_techy = WRENCHABLE,
		sparktech_energy_type = ENERGY_CONSUMER,
		sparktech_net_trigger = TRUE,
		sparktech_energy_max = MAX_ENERGY,
		sparktech_energy_wakeup = 10,
		sparktech_io = TRUE
	},
	_sparkoption = {
		enabled = true,
		light_level = 0
	},
	_sparkoutput = {
		brightness = function(node) return 0 end
	},
	_sparkoutputtype = {
		brightness = type(0)
	},
	light_source = 0
})


minetest.register_node(NAME .. ":light_lv1", {
  description = "Powered light (little)",
  tiles = {
    NAME .. "_lamp_1.png",
  },
	on_timer = function(pos, elapsed) timer(pos, elapsed, 1) end,
	on_construct = function(pos, elapsed) timer(pos, elapsed, 1) end,
	groups = {
		sparktech_techy = WRENCHABLE,
		sparktech_energy_type = ENERGY_CONSUMER,
		sparktech_net_trigger = TRUE,
		sparktech_energy_max = MAX_ENERGY,
		sparktech_energy_wakeup = 10,
		sparktech_io = TRUE
	},
	_sparkoption = {
		enabled = true,
		light_level = 0
	},
	_sparkoutput = {
		brightness = function(node) return 1 end
	},
	_sparkoutputtype = {
		brightness = type(1)
	},
	drop = NAME .. ":light_off",
	light_source = minetest.LIGHT_MAX / 3
})


minetest.register_node(NAME .. ":light_lv2", {
  description = "Powered light (medium)",
  tiles = {
    NAME .. "_lamp_2.png",
  },
	on_timer = function(pos, elapsed) timer(pos, elapsed, 2) end,
	on_construct = function(pos, elapsed) timer(pos, elapsed, 2) end,
	groups = {
		sparktech_techy = WRENCHABLE,
		sparktech_energy_type = ENERGY_CONSUMER,
		sparktech_net_trigger = TRUE,
		sparktech_energy_max = MAX_ENERGY,
		sparktech_energy_wakeup = 10,
		sparktech_io = TRUE
	},
	_sparkoption = {
		enabled = true,
		light_level = 0
	},
	_sparkoutput = {
		brightness = function(node) return 2 end
	},
	_sparkoutputtype = {
		brightness = type(2)
	},
	drop = NAME .. ":light_off",
	light_source = (2 *minetest.LIGHT_MAX /3)
})


minetest.register_node(NAME .. ":light_lv3", {
  description = "Powered light (big)",
  tiles = {
    NAME .. "_lamp_3.png",
  },
	on_timer = function(pos, elapsed) timer(pos, elapsed, 3) end,
	on_construct = function(pos, elapsed) timer(pos, elapsed, 3) end,	
	groups = {
		sparktech_techy = WRENCHABLE,
		sparktech_energy_type = ENERGY_CONSUMER,
		sparktech_net_trigger = TRUE,
		sparktech_energy_max = MAX_ENERGY,
		sparktech_energy_wakeup = 10,
		sparktech_io = TRUE
	},
	_sparkoption = {
		enabled = true,
		light_level = 0
	},
	_sparkoutput = {
		brightness = function(node) return 3 end
	},
	_sparkoutputtype = {
		brightness = type(3)
	},
	drop = NAME .. ":light_off",
	light_source = minetest.LIGHT_MAX
})
